#ifndef _CH9326_LIB_H
#define _CH9326_LIB_H
#ifdef __cplusplus
extern "C" {
#endif

/*********************************************************************  
*   : ch9326_find
* : ̽ch9326豸豸ǰ
* ˵: 
* ú: libusb_init(from libusb.a)
*			libusb_get_device_list(from libusb.a)
*			libusb_get_device_descriptor(from libusb.a)
* ȫֱ: ch9326[]
*     : 
*     : ɹ : ҵ豸(>0)֧16豸ͬʱ, ʧ : 0
*   : tech32                         : 2011-11
*   :                                :
*     : VER 1.0.0.0
***********************************************************************/
extern
unsigned char
ch9326_find(
    void
    );

/*********************************************************************
*   : ch9326_open
* : 豸߳
* ˵:
* ú: libusb_open(from libusb.a)
* ȫֱ: ch9326[]
*     : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
*     : ɹ : 1, ʧ : 0
*   : tech32                         : 2011-11
*   : tech36                         : 2017-11
*     : VER 1.0.0.0
***********************************************************************/
extern
unsigned char
ch9326_open(
    unsigned char index
    );

/*********************************************************************
*   : ch9326_close
* : ر豸
* ˵: 
* ú: libusb_close(from libusb.a)
* ȫֱ: 
*     : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1
			豸(n<=16)
*     : 
			ɹ : 1
			ʧ : 0
*   : tech32                         : 2011-11
*   :                                :
*     : VER 1.0.0.0
***********************************************************************/
extern
unsigned char
ch9326_close(
    unsigned char index
    );

/*********************************************************************
*   : ch9326_set
* : ͨѶʽ
* ˵: 
* ú: libusb_control_transfer(from libusb.a)
* ȫֱ: 
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
*			unsigned char rate : 01 = 300bps, 02 = 600bps, 03 = 1200bps, 04 = 2400bps, 05 = 4800bps, 06 = 9600(default)bps,
*								 07 = 14400bps, 08 = 19200bps, 09 = 28800bps, 10 = 38400bps, 11 = 57600bps, 12 = 76800bps,
*								 13 = 115200bps
*			unsigned char check : 01 = odd, 02 = even, 03 = space, 04 = none(default)
*			unsigned char stop_bits : 01 = 1bit stop bit(default)
*									  02 = 2bit stop bit
*			unsigned char data_bits : 01 = 5bit data bit, 02 = 6bit data bit, 03 = 7bit data bit, 04 = 8bit data bit(default)
*			unsigned char interval :	0x10 = 3ms(default), 0x20 = 6ms, 0x30 = 9ms
*     : ɹ : 1, ʧ : 0
*   : tech32                         : 2011-11
*   :                                :
*     : VER 1.0.0.0
***********************************************************************/
extern
unsigned char
ch9326_set(
	unsigned char index,
	unsigned char rate,
	unsigned char check,
	unsigned char stop_bits,
	unsigned char data_bits,
	unsigned char interval
	);

/*********************************************************************
*   : ch9326_send
* : 
* ˵: 
* ú: libusb_interrupt_transfer(from libusb.a)
* ȫֱ: 
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
			unsigned char *data : ݻ		
			unsigned long length : ݳ
*     : ɹ : ط͵ݳ, ʧ : 0
*   : tech32                         : 2011-11
*   :                                :
*     : VER 1.0.0.0
***********************************************************************/
extern
unsigned long
ch9326_send(
	unsigned char index,
	unsigned char *data,
	unsigned long length
	);

/*********************************************************************
*   : ch9326_recv
* : 
* ˵: 
* ú: 
* ȫֱ: 
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
			unsigned char *data : ݻ
			unsigned long length : ݳ
*     : ɹ : ط͵ݳ, ʧ : 0
*   : tech32                         : 2011-11
*   :                                :
*     : VER 1.0.0.0
***********************************************************************/
extern
unsigned long
ch9326_recv(
	unsigned char index,
    char *data,
	unsigned long length
	);

/*********************************************************************
*   : ch9326_set_gpiodata
* :
* ˵:
* ú: libusb_control_transfer(from libusb.a)
* ȫֱ:
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
*			unsigned char data : λ0IO1ƽ0Ϊ͵ƽ1Ϊߵƽ
*								 λ1IO2ƽ0Ϊ͵ƽ1Ϊߵƽ
*     :
            ɹ : 1
            ʧ : 0
*   : tech32                         : 2011-11
*   : tech33                         : 2014-11
*     : VER 1.0.0.0
***********************************************************************/
extern unsigned char
ch9326_set_gpiodata(
    unsigned char index,
    unsigned char data
    );

/*********************************************************************
*   : ch9326_set_gpiodir
* :
* ˵:
* ú: libusb_control_transfer(from libusb.a)
* ȫֱ:
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
*			unsigned char dir : λ0IO10Ϊ롢1Ϊ
*						 		λ1IO20Ϊ롢1Ϊ
*     :
            ɹ : 1
            ʧ : 0
*   : tech32                         : 2011-11
*   : tech33                         : 2014-11
*     : VER 1.0.0.0
***********************************************************************/
extern unsigned char
ch9326_set_gpiodir(
    unsigned char index,
    unsigned char dir
    );

/*********************************************************************
*   : ch9326_set_gpio
* :
* ˵:
* ú: libusb_control_transfer(from libusb.a)
* ȫֱ:
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
*			unsigned char dir : λ0IO10Ϊ롢1Ϊ
*						 		λ1IO20Ϊ롢1Ϊ
*			unsigned char data : λ0IO1ƽ0Ϊ͵ƽ1Ϊߵƽ
*								 λ1IO2ƽ0Ϊ͵ƽ1Ϊߵƽ
*     :
            ɹ : 1
            ʧ : 0
*   : tech32                         : 2011-11
*   :                                :
*     : VER 1.0.0.0
***********************************************************************/
extern unsigned char
ch9326_set_gpio(
    unsigned char index,
    unsigned char dir,
    unsigned char data
    );

/*********************************************************************
*   : ch9326_get_gpio
* :
* ˵:
* ú: libusb_control_transfer(from libusb.a)
* ȫֱ:
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
*			unsigned char data : λ5ʾIO1ƽ״̬Ϊ1ʾߵƽΪ0ʾ͵ƽ
                                 λ3ʾIO2ƽ״̬Ϊ1ʾߵƽΪ0ʾ͵ƽ
*     :
            ɹ : 1
            ʧ : 0
*   : tech32                         : 2011-11
*   :                                :
*     : VER 1.0.0.0
***********************************************************************/
extern unsigned char
ch9326_get_gpio(
    unsigned char index,
    char *data
    );

/*********************************************************************
*   : ch9326_connected
* : 
* ˵:
* ú:
* ȫֱ:
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
*     : ɹ : 1, ʧ : 0
*   : tech33                        : 2014-11
*   :                                      :
*     : VER 1.0.0.0
***********************************************************************/
extern unsigned char ch9326_connected(unsigned char index);

/*********************************************************************
*   : ch9326_get_manufacturer_string
* : ȡַ
* ˵: 
* ú: libusb_get_string_descriptor
* ȫֱ: 
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
			unsigned char *data : ݻ׵ַ
			unsigned long length : С
*     : ɹ : 1, ʧ : 0
*   : tech36                         : 2017-5
*   :                                      :
*     : VER 1.0.0.0
***********************************************************************/
extern unsigned char
ch9326_get_manufacturer_string(
	unsigned char index,
	unsigned char *data,
	unsigned long length
	);

/*********************************************************************
*   : ch9326_get_product_string
* : ȡƷַ
* ˵: 
* ú: libusb_get_string_descriptor
* ȫֱ: 
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
			unsigned char *data : ݻ׵ַ
			unsigned long length : С
*     : ɹ : 1, ʧ : 0
*   : tech36                         : 2017-5
*   :                                      :
*     : VER 1.0.0.0
***********************************************************************/
extern unsigned char
ch9326_get_product_string(
	unsigned char index,
	unsigned char *data,
	unsigned long length
	);

/*********************************************************************
*   : ch9326_get_serial_number_string
* : ȡкַ
* ˵: 
* ú: libusb_get_string_descriptor
* ȫֱ: 
*     : unsigned char index : 豸ţ0Ӧ1豸1Ӧ2豸... nӦn+1豸(n<=16)
			unsigned char *data : ݻ׵ַ
			unsigned long length : С
*     : ɹ : 1, ʧ : 0
*   : tech36                         : 2017-5
*   :                                      :
*     : VER 1.0.0.0
***********************************************************************/
extern unsigned char
ch9326_get_serial_number_string(
	unsigned char index,
	unsigned char *data,
	unsigned long length
	);

#ifdef __cplusplus
}
#endif

#endif // _CH9326_LIB_H
